import React, { useRef, useState, useMemo, useEffect, useCallback } from 'react';
import { useDrop, useDrag, DndProvider } from 'react-dnd';
import { HTML5Backend } from 'react-dnd-html5-backend';
import classnames from 'classnames';
import { Icon } from '@highlight-ui/icon';

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function __awaiter(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
}
function __generator(thisArg, body) {
  var _ = {
      label: 0,
      sent: function () {
        if (t[0] & 1) throw t[1];
        return t[1];
      },
      trys: [],
      ops: []
    },
    f,
    y,
    t,
    g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;
  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }
  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");
    while (g && (g = 0, op[0] && (_ = 0)), _) try {
      if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
      if (y = 0, t) op = [op[0] & 2, t.value];
      switch (op[0]) {
        case 0:
        case 1:
          t = op;
          break;
        case 4:
          _.label++;
          return {
            value: op[1],
            done: false
          };
        case 5:
          _.label++;
          y = op[1];
          op = [0];
          continue;
        case 7:
          op = _.ops.pop();
          _.trys.pop();
          continue;
        default:
          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
            _ = 0;
            continue;
          }
          if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
            _.label = op[1];
            break;
          }
          if (op[0] === 6 && _.label < t[1]) {
            _.label = t[1];
            t = op;
            break;
          }
          if (t && _.label < t[2]) {
            _.label = t[2];
            _.ops.push(op);
            break;
          }
          if (t[2]) _.ops.pop();
          _.trys.pop();
          continue;
      }
      op = body.call(thisArg, _);
    } catch (e) {
      op = [6, e];
      y = 0;
    } finally {
      f = t = 0;
    }
    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
}
function __spreadArray(to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
}
var styles$2 = {
  "draggableItem": "DraggableItem-module__CX71RiGs__v3-0-91",
  "hideItem": "DraggableItem-module__WGcvUiq5__v3-0-91"
};
var defaultValidDragComponentIDs = [];
function DraggableItem(_a) {
  var _b;
  var children = _a.children,
    isSortable = _a.isSortable,
    isDraggable = _a.isDraggable,
    index = _a.index,
    onMoveItem = _a.onMoveItem,
    onDropItem = _a.onDropItem,
    onDropOutside = _a.onDropOutside,
    onDragUndo = _a.onDragUndo,
    _c = _a.validDragComponentIds,
    validDragComponentIds = _c === void 0 ? defaultValidDragComponentIDs : _c,
    draggableTypeId = _a.draggableTypeId,
    draggableItem = _a.draggableItem;
  var dragIconRef = useRef(null);
  var dropRef = useRef(null);
  var _d = useDrop({
      accept: __spreadArray([draggableTypeId], validDragComponentIds, true),
      collect: function (monitor) {
        return {
          handlerId: monitor.getHandlerId(),
          isOver: monitor.isOver(),
          canDrop: monitor.canDrop()
        };
      },
      canDrop: function (item) {
        var _a;
        return !draggableItem.disabled && !((_a = item.dropTarget) === null || _a === void 0 ? void 0 : _a.active);
      },
      drop: function (item) {
        if (item.type !== draggableTypeId) {
          item.droppableZone = 'outside';
          // this cast is needed because the target might be different
          item.dropTarget = draggableItem;
        }
        onDropItem(item);
      },
      hover: function (item, monitor) {
        if (!dragIconRef.current) {
          // If the target area is a different we set the drop target to the one that is being hover over
          item.dropTarget = draggableItem;
          return;
        }
        if (item.type !== draggableTypeId) {
          return;
        }
        var dragIndex = item.index;
        var hoverIndex = index;
        // Don't replace items with themselves
        if (dragIndex === hoverIndex) {
          return;
        }
        // Determine rectangle on screen
        var hoverBoundingRect = dragIconRef.current.getBoundingClientRect();
        // Get vertical middle
        var hoverMiddleY = (hoverBoundingRect.bottom - hoverBoundingRect.top) / 2;
        // Determine mouse position
        var clientOffset = monitor.getClientOffset();
        if (!clientOffset) return;
        // Get pixels to the top
        var hoverClientY = clientOffset.y - hoverBoundingRect.top;
        // Only perform the move when the mouse has crossed half of the items height
        // When dragging downwards, only move when the cursor is below 50%
        // When dragging upwards, only move when the cursor is above 50%
        // Dragging downwards
        if (dragIndex < hoverIndex && hoverClientY < hoverMiddleY) {
          return;
        }
        // Dragging upwards
        if (dragIndex > hoverIndex && hoverClientY > hoverMiddleY) {
          return;
        }
        if (isSortable) {
          item.index = hoverIndex;
          onMoveItem(dragIndex, hoverIndex);
        }
        // Note: we're mutating the monitor item here!
        // Generally it's better to avoid mutations,
        // but it's good here for the sake of performance
        // to avoid expensive index searches.
        item.droppableZone = 'inside';
      }
    }),
    _e = _d[0],
    handlerId = _e.handlerId,
    isOver = _e.isOver,
    canDrop = _e.canDrop,
    drop = _d[1];
  var _f = useDrag({
      item: {
        type: draggableTypeId,
        id: draggableItem.key,
        index: index,
        initialIndex: index,
        droppableZone: 'inside'
      },
      collect: function (monitor) {
        return {
          isDragging: monitor.isDragging()
        };
      },
      canDrag: !draggableItem.disabled && isDraggable,
      end: function (item, monitor) {
        if (!item) {
          return;
        }
        var didDrop = monitor.didDrop();
        if (!didDrop || item.droppableZone === 'outside') {
          onDragUndo(item.index, item.initialIndex);
        }
        if (didDrop && item.droppableZone === 'outside') {
          onDropOutside(item);
        }
      }
    }),
    isDragging = _f[0].isDragging,
    drag = _f[1],
    dragPreview = _f[2];
  dragPreview(dropRef.current, {
    captureDraggingState: true
  });
  drag(dragIconRef);
  drop(dropRef);
  return /*#__PURE__*/React.createElement("li", {
    ref: dropRef,
    "data-handler-id": handlerId,
    className: classnames(styles$2.draggableItem, (_b = {}, _b[styles$2.hideItem] = isDragging, _b)),
    key: draggableItem.key
  }, typeof children === 'function' && children({
    dragRef: isDraggable ? dragIconRef : undefined,
    canDrop: canDrop,
    isOver: isOver
  }));
}
var styles$1 = {
  "list": "DragAndDropList-module__Iuyveh-M__v3-0-91"
};
function WithDragBehavior(_a) {
  var _this = this;
  var list = _a.list,
    renderItem = _a.renderItem,
    dragProps = _a.dragProps;
  var _b = useState(list),
    internalList = _b[0],
    setInternalList = _b[1];
  // eslint-disable-next-line react-hooks/exhaustive-deps
  var initialList = useMemo(function () {
    return list;
  }, []);
  useEffect(function () {
    setInternalList(list);
  }, [list]);
  useEffect(function () {
    var _a;
    var resetToOriginalList = function () {
      setInternalList(initialList);
      if (dragProps.onReset) {
        dragProps.onReset(initialList);
      }
    };
    if ((_a = dragProps.resetButtonRef) === null || _a === void 0 ? void 0 : _a.current) {
      dragProps.resetButtonRef.current.addEventListener('click', resetToOriginalList);
    }
    return function () {
      var _a;
      if ((_a = dragProps.resetButtonRef) === null || _a === void 0 ? void 0 : _a.current) {
        dragProps.resetButtonRef.current.removeEventListener('click', resetToOriginalList);
      }
    };
  }, [dragProps, initialList]);
  var onMoveItem = useCallback(function (dragIndex, hoverIndex) {
    var newList = __spreadArray([], internalList, true);
    var dragItem = newList[dragIndex];
    newList.splice(dragIndex, 1);
    newList.splice(hoverIndex, 0, dragItem);
    setInternalList(newList);
    return newList;
  }, [internalList]);
  var onDragUndo = useCallback(function (idx, initialIndex) {
    var undoList = onMoveItem(idx, initialIndex);
    if (dragProps.onUndo) {
      dragProps.onUndo(undoList);
    }
  }, [onMoveItem, dragProps]);
  var onDropItem = useCallback(function (item) {
    return __awaiter(_this, void 0, void 0, function () {
      var droppedItem, onSortResult;
      return __generator(this, function (_a) {
        if (dragProps.behavior === 'sort' || dragProps.behavior === 'sortAndDropOutside') {
          droppedItem = internalList.find(function (_a) {
            var key = _a.key;
            return key === item.id;
          });
          if (!droppedItem) return [2 /*return*/];
          onSortResult = dragProps.onSort(internalList, droppedItem);
          if (onSortResult) {
            onSortResult.catch(function () {
              return onDragUndo(item.index, item.initialIndex);
            });
          }
        }
        return [2 /*return*/];
      });
    });
  }, [dragProps, internalList, onDragUndo]);
  var onRemoveItem = useCallback(function (item) {
    var newList = __spreadArray([], internalList, true);
    var prevList = __spreadArray([], internalList, true);
    newList.splice(item.index, 1);
    setInternalList(newList);
    return {
      newList: newList,
      prevList: prevList
    };
  }, [internalList]);
  var onDropOutside = useCallback(function (item) {
    if (dragProps.behavior === 'sort' || dragProps.behavior === 'dropInside') {
      return;
    }
    if (!item.dropTarget) return;
    var onDropOutsideResult = dragProps.onDropOutside(internalList[item.index], item.dropTarget);
    var prevList = onRemoveItem(item).prevList;
    if (onDropOutsideResult) {
      onDropOutsideResult.catch(function () {
        setInternalList(prevList);
        if (dragProps.onUndo) {
          dragProps.onUndo(prevList);
        }
      });
    }
  }, [dragProps, internalList, onRemoveItem]);
  return /*#__PURE__*/React.createElement(DndProvider, {
    backend: HTML5Backend
  }, /*#__PURE__*/React.createElement("ul", {
    className: styles$1.list
  }, internalList.map(function (item, index) {
    return /*#__PURE__*/React.createElement(DraggableItem, {
      validDragComponentIds: dragProps.validDragComponentIds,
      draggableTypeId: dragProps.id,
      key: item.key,
      draggableItem: item,
      index: index,
      onMoveItem: onMoveItem,
      onDropItem: onDropItem,
      onDropOutside: onDropOutside,
      onDragUndo: onDragUndo,
      isDraggable: dragProps.behavior !== 'dropInside',
      isSortable: dragProps.behavior === 'sort' || dragProps.behavior === 'sortAndDropOutside'
    }, function (_a) {
      var dragRef = _a.dragRef,
        canDrop = _a.canDrop,
        isOver = _a.isOver;
      return renderItem({
        item: item,
        index: index,
        dragRef: dragRef,
        isOver: isOver,
        canDrop: canDrop
      });
    });
  })));
}
function DragAndDropList(_a) {
  var list = _a.list,
    renderItem = _a.renderItem,
    dragProps = _a.dragProps,
    listItemClassName = _a.listItemClassName,
    listProps = _a.listProps,
    listItemProps = _a.listItemProps;
  if (!dragProps) {
    return /*#__PURE__*/React.createElement("ul", __assign({}, listProps, {
      className: styles$1.list
    }), list.map(function (item, index) {
      return /*#__PURE__*/React.createElement("li", __assign({}, listItemProps, {
        className: listItemClassName,
        key: item.key
      }), renderItem({
        item: item,
        index: index
      }));
    }));
  }
  return /*#__PURE__*/React.createElement(WithDragBehavior, {
    list: list,
    renderItem: renderItem,
    dragProps: dragProps
  });
}
var styles = {
  "container": "DragIcon-module__NVE8VheZ__v3-0-91",
  "gripIcon": "DragIcon-module__3gjEOtJA__v3-0-91"
};
var DragIcon = function (_a) {
  var dragRef = _a.dragRef,
    disabled = _a.disabled;
  return /*#__PURE__*/React.createElement("div", {
    className: styles.container,
    ref: dragRef,
    "data-test-id": "draggable"
  }, /*#__PURE__*/React.createElement(Icon, {
    name: "grip-vertical",
    size: 14,
    type: "solid",
    color: disabled ? 'icon-disabled' : 'icon-subdued',
    className: styles.gripIcon
  }));
};
export { DragAndDropList, DragIcon, DraggableItem };
//# sourceMappingURL=index.js.map
