import React from 'react';
import { DragObjectWithType } from 'react-dnd';
export declare type Item = {
    key: string;
    disabled?: boolean;
    active?: boolean;
};
export declare type DragItem<D> = DragObjectWithType & {
    id: string;
    index: number;
    initialIndex: number;
    droppableZone: 'inside' | 'outside';
    dropTarget?: D;
};
export declare type DraggableItemProps<T, D> = {
    isSortable: boolean;
    isDraggable: boolean;
    index: number;
    onMoveItem: (dragIndex: number, hoverIndex: number) => void;
    onDropItem: (item: DragItem<D>) => void;
    onDropOutside: (item: DragItem<D>) => void;
    onDragUndo: (idx: number, initialIndex: number) => void;
    validDragComponentIds?: string[];
    draggableTypeId: string;
    draggableItem: T;
};
declare function DraggableItem<T extends Item, D extends Item>({ children, isSortable, isDraggable, index, onMoveItem, onDropItem, onDropOutside, onDragUndo, validDragComponentIds, draggableTypeId, draggableItem, }: React.PropsWithChildren<DraggableItemProps<T, D>>): JSX.Element;
export default DraggableItem;
